﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace GIT
{
    public partial class FormRegsiter : Form
    {
        public Department selectedDepartment;
        public Personnel selectedPersonnel;
        int lst_index_personel;
        int lst_index;
        public FormRegsiter()
        {
            InitializeComponent();
        }
        private void fill_data()
        {
            listview_personel.Items.Clear();
            foreach (Personnel personel in myData.personnels)
            {
                ListViewItem item = new ListViewItem();
                item.Tag = personel;
                item.Text = personel.Id;
                item.SubItems.Add(personel.Name);
                item.SubItems.Add(personel.MaxDateWorkInMonth.ToString());
                item.SubItems.Add(personel.Family);

                item.SubItems.Add(personel.Adres);

                listview_personel.Items.Add(item);
            }

        }

        private void FormRegsiter_Load(object sender, EventArgs e)
        {
            lst_index_personel  = -1;
            lst_index = -1;
            btn_insert.Enabled = false;
            button2.Enabled = false;
            fill_data();

           //Load Departments from myData to DepartmentComboBox
           foreach (Department department in myData.departments)
               cmbDepartment.Items.Add(department);
           cmbDepartment.SelectedIndex = 0;
              
        }



        private void button1_Click(object sender, EventArgs e)
        {
            //First Get selected Personnel and Selected Department
        //Personnel selectedPersonnel = (Personnel)cmbPersonnels.SelectedItem ;
            if (lst_index_personel == -1)
            {
                MessageBox.Show("هیچ پرسنلی برای اضافه به بخش انتخاب نشده است");
                return;
            }
            
            selectedPersonnel =myData .personnels [lst_index_personel ];
            selectedDepartment = (Department)cmbDepartment.SelectedItem;

            if (selectedDepartment.maxperson == 0)
            {
                MessageBox.Show("ظرفیت این بخش تکمیل است");
                return;
            }
            if(selectedPersonnel.CheckIfhasDepartment())
            {
                MessageBox.Show("پرسنل انتخاب شده در بخش ديگري فعال است");
                return;

            }
         
            //Add Personnel to the Department

            selectedDepartment.AddPersonnel(selectedPersonnel,lst_index_personel );

            //Update the Department Project's List
            listView_DepartmentProjects.Items.Clear();


            foreach (Personnel personnel in selectedDepartment.personnels)
            {
                ListViewItem item = new ListViewItem();
                item.Tag = personnel;
                item.Text = personnel.Id;
                item.SubItems.Add(personnel.Name);
                item.SubItems.Add(personnel.Family);
                item.SubItems.Add(personnel.Department.name);
                item.SubItems.Add(personnel.Item_inList1.ToString());

                listView_DepartmentProjects.Items.Add(item);
            }
         
        }

     

        private void listview_personel_SelectedIndexChanged(object sender, EventArgs e)
        {
            ListView.SelectedIndexCollection indexes = listview_personel.SelectedIndices;
            foreach (int index1 in indexes)
            {
                lst_index_personel = index1;
            }
        }



        private void cmbDepartment_SelectedIndexChanged(object sender, EventArgs e)
        {
            groupBox3.Text = "پرسنل شاغل در بخش " + "  " + cmbDepartment.Text;
            Department selectedDepartment = (Department)cmbDepartment.SelectedItem;
            //Clean the listView_DepartmentProjects 
            listView_DepartmentProjects.Items.Clear();

            //Load the Selected Department Object's Personnels and Show them in listView_DepartmentProjects
            foreach (Personnel personnel in selectedDepartment.personnels)
            {
                ListViewItem item = new ListViewItem();
                item.Tag = personnel;
                item.Text = personnel.Id;
                item.SubItems.Add(personnel.Name);
                item.SubItems.Add(personnel.Family);
                item.SubItems.Add(personnel.Department.name);
                item.SubItems.Add(personnel.Item_inList1.ToString());
                listView_DepartmentProjects.Items.Add(item);

            }
            
        }

        private void button2_Click(object sender, EventArgs e)
        {
          //  selectedDepartment.RemovePersonel();
            Department selectedDepartment = (Department)cmbDepartment.SelectedItem;
            selectedPersonnel = myData.personnels[lst_index];
            selectedDepartment.RemovePersonel(selectedPersonnel);
            listView_DepartmentProjects.Items.Clear();

            //Load the Selected Department Object's Personnels and Show them in listView_DepartmentProjects
            foreach (Personnel personnel in selectedDepartment.personnels)
            {
                ListViewItem item = new ListViewItem();
                item.Tag = personnel;
                item.Text = personnel.Id;
                item.SubItems.Add(personnel.Name);
                item.SubItems.Add(personnel.Family);
                item.SubItems.Add(personnel.Department.name);
                item.SubItems.Add(personnel.Item_inList1.ToString());
                listView_DepartmentProjects.Items.Add(item);
            }
            if (listView_DepartmentProjects.Items.Count == 0)
            {
                button2.Enabled = false;
                btn_insert.Enabled = false;
            }
          
        }

        private void listView_DepartmentProjects_SelectedIndexChanged(object sender, EventArgs e)
        {
            ListView.SelectedListViewItemCollection lst = listView_DepartmentProjects.SelectedItems;
            foreach (ListViewItem item in lst)
            {
                lst_index = int.Parse(item.SubItems[4].Text);
                
               
            }
            if (lst_index == -1)
            {
                btn_insert.Enabled = false;
                button2.Enabled = false;
            }
            else
            {
                btn_insert.Enabled = true;
                button2.Enabled = true;
            }

        }

        private void button3_Click_1(object sender, EventArgs e)
        {
            selectedDepartment = (Department)cmbDepartment.SelectedItem;
            selectedPersonnel = myData.personnels[lst_index];
            FrmAddpersonelwork frm = new FrmAddpersonelwork();
            string s2 = selectedPersonnel.Item_inList1.ToString();
            frm.send(selectedPersonnel, selectedDepartment);
            frm.ShowDialog();
        }

        private void button3_Click_2(object sender, EventArgs e)
        {
            listView_DepartmentProjects.Items[0].Tag  = "fgdgdf";
        }
    }
}